/**
 * Scripts within the customizer controls window.
 *
 * Contextually shows the color hue control and informs the preview
 * when users open or close the front page sections section.
 */

(function( $, api ) {
    wp.customize.bind('ready', function() {
    	// Show message on change.
        var moral_magazine_settings = ['moral_magazine_slider_num', 'moral_magazine_services_num', 'moral_magazine_projects_num', 'moral_magazine_testimonial_num', 'moral_magazine_blog_section_num', 'moral_magazine_reset_settings', 'moral_magazine_testimonial_num', 'moral_magazine_partner_num'];
        _.each( moral_magazine_settings, function( moral_magazine_setting ) {
            wp.customize( moral_magazine_setting, function( setting ) {
                var blogsterNotice = function( value ) {
                    var name = 'needs_refresh';
                    if ( value && moral_magazine_setting == 'moral_magazine_reset_settings' ) {
                        setting.notifications.add( 'needs_refresh', new wp.customize.Notification(
                            name,
                            {
                                type: 'warning',
                                message: localized_data.reset_msg,
                            }
                        ) );
                    } else if( value ){
                        setting.notifications.add( 'reset_name', new wp.customize.Notification(
                            name,
                            {
                                type: 'info',
                                message: localized_data.refresh_msg,
                            }
                        ) );
                    } else {
                        setting.notifications.remove( name );
                    }
                };

                setting.bind( blogsterNotice );
            });
        });

        /* === Radio Image Control === */
        api.controlConstructor['radio-color'] = api.Control.extend( {
            ready: function() {
                var control = this;

                $( 'input:radio', control.container ).change(
                    function() {
                        control.setting.set( $( this ).val() );
                    }
                );
            }
        } );

         // Sortable sections
        jQuery( 'ul.moral-magazine-sortable-list' ).sortable({
            handle: '.moral-magazine-drag-handle',
            axis: 'y',
            update: function( e, ui ){
                jQuery('input.moral-magazine-sortable-input').trigger( 'change' );
            }
        });

        /* On changing the value. */
        jQuery( "body" ).on( 'change', 'input.moral-magazine-sortable-input', function() {
            /* Get the value, and convert to string. */
            this_checkboxes_values = jQuery( this ).parents( 'ul.moral-magazine-sortable-list' ).find( 'input.moral-magazine-sortable-input' ).map( function() {
                return this.value;
            }).get().join( ',' );

            /* Add the value to hidden input. */
            jQuery( this ).parents( 'ul.moral-magazine-sortable-list' ).find( 'input.moral-magazine-sortable-value' ).val( this_checkboxes_values ).trigger( 'change' );

        });

        // Deep linking for counter section to about section.
        jQuery('.moral-magazine-edit').click(function(e) {
            e.preventDefault();
            var jump_to = jQuery(this).attr( 'data-jump' );
            wp.customize.section( jump_to ).focus()
        });

    });
})( jQuery, wp.customize );
